class Drag {
  isDraging = false
  elx = 0
  ely = 0
  target = null //拖拽目标
  handler = null//拖拽触发点
  constructor(el, { target, handler }) {
    if (target)
      this.target = el.querySelector(target);
    else
      this.target = el;

    if (handler)
      this.handler = el.querySelector(handler);
    else
      this.handler = this.target

    this.bindEvents();
  }
  bindEvents() {
    let el = this.target;
    this.handler.addEventListener('mousedown', ev => {
      if (ev.which === 1) {
        this.isDraging = true;
        this.elx = ev.pageX - el.offsetLeft;
        this.ely = ev.pageY - el.offsetTop;
      }
    });
    el.addEventListener('mouseup', ev => {
      {
        this.isDraging = false;
      }
    })
    window.addEventListener('mousemove', this._dragHandler.bind(this))
  }
  _dragHandler(ev) {
    if (!this.isDraging) return;
    this._positionTo((ev.clientX - this.elx), (ev.clientY - this.ely));
    ev.preventDefault();
    return false;
  }
  _positionTo(x, y) {
    this.target.style.left = x + 'px';
    this.target.style.top = y + 'px';
  }
  destroy() {
    window.removeEventListener('mousemove', this._dragHandler);
  }
}
export { Drag }
export default {
  name: 'cpt-drag',
  directive: {
    bind(el, { value }) {
      let $el = el || this.el;
      $el._dragInstance = new Drag($el, value || {});
    },
    unbind() {
      this.el._dragInstance && this.el._dragInstance.destory();
    }
  }
}
